const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const teamService = require("./team.service");

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    teamService
        .create(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    teamService
        .getAll(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    teamService
        .option(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    teamService
        .count()
        .then((result) => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    teamService
        .update(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    teamService
        .enabled(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    teamService
        .delete(req.params.id)
        .then((result) => res.json(result))
        .catch(next);
}
